package com.ejie.ab79.dao.inspecciones;

import java.util.List;

import com.ejie.ab79.model.Inspectores;
import com.ejie.ab79.model.REST.servicioWeb.InspeccionDato;
import com.ejie.ab79.model.REST.servicioWeb.InspeccionDocumentacion;
import com.ejie.ab79.model.expedientes.Expedientes;
import com.ejie.ab79.model.inspecciones.Inspecciones;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableRowDto;

/**
 * InspeccionesDao  
 * 
 *  
 */

public interface InspeccionesDao {

	/**
	 * Inserts a single row in the Inspecciones table.
	 *
	 * @param inspecciones
	 *            Inspecciones
	 * @return Inspecciones
	 */
	Inspecciones add(Inspecciones inspecciones);

	/**
	 * Updates a single row in the Inspecciones table.
	 *
	 * @param inspecciones
	 *            Inspecciones
	 * @return Inspecciones
	 */
	Inspecciones update(Inspecciones inspecciones);

	/**
	 * Finds a single row in the Inspecciones table.
	 *
	 * @param inspecciones
	 *            Inspecciones
	 * @return Inspecciones
	 */
	Inspecciones find(Inspecciones inspecciones);

	Inspecciones findByIdInspeccionMovil(String idInspeccionMovil);

	/**
	 * Removes a single row in the Inspecciones table.
	 *
	 * @param inspecciones
	 *            Inspecciones
	 */
	void remove(Inspecciones inspecciones);

	/**
	 * Finds a List of rows in the Inspecciones table.
	 *
	 * @param inspecciones
	 *            Inspecciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List
	 */
	List<Inspecciones> findAll(Inspecciones inspecciones, TableRequestDto tableRequestDto);

	/**
	 * Finds rows in the Inspecciones table using like.
	 *
	 * @param inspecciones
	 *            Inspecciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List
	 */
	List<Inspecciones> findAllLike(Inspecciones inspecciones, TableRequestDto tableRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE
	 */

	/**
	 * Filter in the Inspecciones table.
	 *
	 * @param filterInspecciones
	 *            Inspecciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 */
	void removeMultiple(Inspecciones filterInspecciones, TableRequestDto tableRequestDto, Boolean startsWith);

	/**
	 * Counts rows in the Inspecciones table using like.
	 *
	 * @param inspecciones
	 *            Inspecciones
	 * @param startsWith
	 *            Boolean
	 * @return Long
	 */
	Long findAllLikeCount(Inspecciones inspecciones, Boolean startsWith);

	/**
	 * Counts rows in the Inspecciones table.
	 *
	 * @param inspecciones
	 *            Inspecciones
	 * @return Long
	 */
	Long findAllCount(Inspecciones inspecciones);

	/**
	 * Reorder selection.
	 *
	 * @param filterInspecciones
	 *            Inspecciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Inspecciones>>
	 */
	List<TableRowDto<Inspecciones>> reorderSelection(Inspecciones filterInspecciones, TableRequestDto tableRequestDto,
			Boolean startsWith);

	/**
	 * Searches in the Usuario table.
	 *
	 * @param filterInspecciones
	 *            Inspecciones
	 * @param searchInspecciones
	 *            Inspecciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @param startsWith
	 *            Boolean
	 * @return List<TableRowDto<Inspecciones>>
	 */
	List<TableRowDto<Inspecciones>> search(Inspecciones filterInspecciones, Inspecciones searchInspecciones,
			TableRequestDto tableRequestDto, Boolean startsWith);

	/*
	 * OPERACIONES RUP_TABLE JERARQUIA
	 */

	/**
	 * Filter in the hierarchical Inspecciones table.
	 *
	 * @param filterInspecciones
	 *            Inspecciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<JerarquiaDto<Inspecciones>>
	 */
	List<JerarquiaDto<Inspecciones>> findAllLikeJerarquia(Inspecciones filterInspecciones,
			TableRequestDto tableRequestDto);

	/**
	 * Count rows in hierarchy
	 *
	 * @param filterInspecciones
	 *            Inspecciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return Long
	 */
	Long findAllLikeCountJerarquia(Inspecciones filterInspecciones, TableRequestDto tableRequestDto);

	/**
	 * Find dependent hierarchical rows
	 *
	 * @param filterInspecciones
	 *            Inspecciones
	 * @param tableRequestDto
	 *            TableRequestDto
	 * @return List<TableRowDto<Inspecciones>>
	 */
	List<TableRowDto<Inspecciones>> findAllChild(Inspecciones filterInspecciones, TableRequestDto tableRequestDto);

	/**
	 * Exporta Datos al clipBoard
	 *
	 */
	List<Inspecciones> getMultiple(Inspecciones filterInspecciones, TableRequestDto tableRequestDto,
			Boolean startsWith);

	Inspecciones updateDatosBasicos(Inspecciones inspecciones);

	Inspecciones updateProtocolos(Inspecciones inspecciones);

	List<Inspecciones> asignarInspector(List<Inspecciones> listaInspecciones);

	Integer inspeccionesAsociadasDireccion(Integer provinciaPrecargada, Integer direccionPrecargada);

	Integer inspeccionesAsociadas(Integer provinciaPrecargada);

	Inspecciones findByExpedienteOrigenInspeccion(Expedientes expediente);

	Inspecciones findByIdentificadorInspeccion(String identificadorInspeccion);

	/**
	 * Buscar el inspector de una inspección
	 *
	 * @param idInspeccion
	 *            Integer
	 * @return Inspectores
	 */
	Inspectores comprobarInspectorInspeccion(Integer idInspeccion);

	List<InspeccionDato> findInspeccionesREST(String inspector);

	List<InspeccionDocumentacion> findDocumentacionInspeccionesREST(String inspector);

	List<Inspecciones> enviarTablet(List<Inspecciones> listaInspecciones, Integer enviar);

	Inspecciones findPropuestasEnTramite(Inspecciones inspeccion);

	Inspecciones findPropuestasEnviadas(Inspecciones inspeccion);

	Inspecciones findPropuestasExpedienteSancionador(Inspecciones inspeccion);

	Inspecciones findPropuestasSubsanacion(Inspecciones inspeccion);

	Inspecciones updateFechaFinInspeccion(Inspecciones inspecciones);

	Integer findUltimoIdentificadorByAnioDireccion(int anio, String direccionLetra);
}
